import { Indexable, JsonArray, JsonObject, JsonType, SerializableType, InstantiationMethod } from "./util";
export declare function DeserializeMap<T>(data: JsonObject, type: SerializableType<T>, target?: Indexable<T>, instantiationMethod?: InstantiationMethod): Indexable<T>;
export declare function DeserializeArray<T>(data: JsonArray, type: SerializableType<T>, target?: Array<T>, instantiationMethod?: InstantiationMethod): T[];
export declare function DeserializeJSON<T extends JsonType>(data: JsonType, transformKeys?: boolean, target?: JsonType): JsonType;
export declare function Deserialize<T extends Indexable>(data: JsonObject, type: SerializableType<T>, target?: T, instantiationMethod?: InstantiationMethod): T | null;
export declare function DeserializeRaw<T>(data: JsonObject, type: SerializableType<T>, target?: T): T | null;
export declare function DeserializeArrayRaw<T>(data: JsonArray, type: SerializableType<T>, target?: Array<T>): Array<T> | null;
export declare function DeserializeMapRaw<T>(data: Indexable<JsonType>, type: SerializableType<T>, target?: Indexable<T>): Indexable<T> | null;
