"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var InstantiationMethod;
(function (InstantiationMethod) {
    InstantiationMethod[InstantiationMethod["None"] = 0] = "None";
    InstantiationMethod[InstantiationMethod["New"] = 1] = "New";
    InstantiationMethod[InstantiationMethod["ObjectCreate"] = 2] = "ObjectCreate";
})(InstantiationMethod = exports.InstantiationMethod || (exports.InstantiationMethod = {}));
function getTarget(type, target, instantiationMethod) {
    if (target !== null && target !== void 0)
        return target;
    if (type !== null) {
        switch (instantiationMethod) {
            case InstantiationMethod.New:
                return new type();
            case InstantiationMethod.ObjectCreate:
                return Object.create(type.prototype);
        }
    }
    return {};
}
exports.getTarget = getTarget;
function isPrimitiveType(type) {
    return (type === String ||
        type === Boolean ||
        type === Number ||
        type === Date ||
        type === RegExp);
}
exports.isPrimitiveType = isPrimitiveType;
function setBitConditionally(value, bits, condition) {
    if (condition) {
        return value | bits;
    }
    else {
        return value & ~bits;
    }
}
exports.setBitConditionally = setBitConditionally;
//# sourceMappingURL=util.js.map